;dssensonsor auf portX pinY
;*************************temp eines sensors auslesen******************		
ds18_t_skip_rom:	
		cli
		rcall		ds_reset			;wer ist da???
		rcall		skip_rom			;ansprechen aller slaves +
		rcall		convert_t			;start tempmessung
		rcall		ds_reset			;wer ist da???
		rcall		skip_rom			;ansprechen aller slaves+vorbereitung der tempmessung 		
		rcall		read_scratchpad		;Sensor auslesen tempim temp_lsb, vorzeichen im temp_msb
		rcall		ds_reset
		rcall		Diven_2				;Div /2 mit Beachtung Vorzeichen
		sei
		ret

;*******************mehrere sensoren anhand adresse auslesen***********
ds18_t_adr:
		cli
		rcall		ds_reset			;wer ist da???
		rcall		skip_rom			;ansprechen aller slaves + 
		rcall		convert_t			;start tempmessung
		
		clr			zl					;
		clr			zh					;pointer clr
		sts			eep_adrl,zl			;
		sts			eep_adrh,zh			;		
		rcall		rd_ds_n				;anzahl ds aus eeprom holen = Durchlufe
		lds			cnt,dsnmax			;cnt = dsnmax
ds18_t_adr2:
		rcall		adr_ee_sr			;adresse von eeprom in sram laden
		rcall		ds18_get_t_adr		;sendet adressen um temp zu lesen
		rcall		Diven_2				;Div /2 mit Beachtung Vorzeichen
		dec			cnt					;-1
		cpi			cnt,$00				;=?
		brne		ds18_t_adr2			;!= zu label springen
		sei
		ret		

ds18_get_t_adr:
		rcall		ds_reset			;wer ist da???
		rcall		match_rom			;adresse senden
		rcall		read_scratchpad		;auslesen
		rcall		ds_reset			;
		ret	

;*****************************uniqe-serial*****************************
ds18_get_ser:
		rcall		ds_reset			;wer ist da???
		rcall		read_rom			;Befehl senden um adresse lesen 
		rcall		adr_sr_ee			;DS-Adress von SRAM -> EEProm
		ret

;*********************adresse in EEprom ablegen************************
adr_sr_ee:
		clr			zl
		clr			zh
		sts			eep_adrl,zl
		sts			eep_adrh,zh			;immer auf anfang setzen
		rcall		load_ID_rng_Y		;Speicherbereich laden
adr_sr_ee2:
		rcall		eeprom_read			;von erster adresse lesen 
		cpi			temp0,$10			;wenn keine $10
		brne		adr_sr_ee3			;dann springe
		rcall		nxt_adr_eep			;nchste eeprom-ZEILE!!!!!
		lds			temp0,eep_adrh
		cpi			temp0,$01			;= $100 = 256/8byte = N-Sensoren	
		breq		eeprom_voll
		rjmp		adr_sr_ee2			;sonst ist ein sensor schon abgespeichert
adr_sr_ee3:
		ld			temp0,y+			;von pointer y laden
		rcall		eeprom_write		;schreibe wert von y in eeprom
		rcall		adr_cnt				;nchste adresse vorbereiten
		cpi			yl,dsIDrng+8		;yl = stopadresse ?
		brne		adr_sr_ee3			;wenn != stopadresse zu label 
		lds			temp0,dsnmax		;sonst weiter
		inc			temp0				;wieviele sensoren abgespeichert wurden
		sts			dsnmax,temp0
		rcall		wr_ds_n				;und anzahl der DS in eeprom speichern
		ret

eeprom_voll:
		ldi			temp1,0b10010100
	;	rcall		out_max_sens		;hier knnte ein Anzeige realisiert werden
		rcall		nxt_adr_eem			;weil max. Anzahl der sensoren erreicht ist
		ret

nxt_adr_eep:
		adiw		zh:zl,$10			;EEP ADR plus
		sts			eep_adrl,zl
		sts			eep_adrh,zh	
		ret

nxt_adr_eem:
		sbiw		zh:zl,$10			;EEP ADR minus
		sts			eep_adrl,zl
		sts			eep_adrh,zh	
		ret

;*********************************Adresse von ee in sram*****************
adr_ee_sr:								;adresse muss vorher in eep_adrh:l geladen werden in dem programm was dieses aufruft
		rcall		load_ID_rng_Y		;weil adr_ee_sr wird auch zum auslesen weiter Sensoren genutzt
adr_ee_sr_1:
		rcall		eeprom_read			;auslesen der adr beginnend mit family code (10h)	
		st			y+,temp0			;8byte in sram schreiben
		rcall		adr_cnt				;neu adresse hoch zhlen eeprom spalte
		cpi			yl,dsIDrng+8		;yl = stoppadresse ??
		brne		adr_ee_sr_1			;nein
		rcall		nxt_adr_eep			;sonst neue adresse laden
		ret

;********************Pointer setzen**************************************
load_ID_rng_Y:
		ldi			yl,low(dsIDrng)		;ID's speichern
		ldi			yh,high(dsIDrng)
		ret

load_dstemp_Y:
		ldi			yh,high(dstemp)		;Temperaturbereich
		ldi			yl,low(dstemp)	
		ret

;*********************Anzahl der DS's von eeprom lesen feste Adresse*****
rd_ds_n:lds			temp1,eep_adrl
		lds			temp2,eep_adrh
		push		temp1
		push		temp2
		ldi			temp0,$0f
		sts			eep_adrl,temp0
		clr			temp2
		sts			eep_adrh,temp2
		rcall		eeprom_read
		sts			dsnmax,temp0
		pop			temp2
		pop			temp1
		sts			eep_adrh,temp2
		sts			eep_adrl,temp1
		ret

;********************Anzahl der DS's in eeprom schreiben feste Adresse****
wr_ds_n:lds			temp1,eep_adrl
		lds			temp2,eep_adrh
		push		temp1
		push		temp2
		ldi			temp1,$0f
		sts			eep_adrl,temp1
		clr			temp2
		sts			eep_adrh,temp2
		lds			temp0,dsnmax
		rcall		eeprom_write
		pop			temp2
		pop			temp1
		sts			eep_adrh,temp2
		sts			eep_adrl,temp1
		ret

;***ansprechen aller slave's, tempmessung auslsen aller sensoren*******
;***nachfolgend muss keine adr gesendet werden nur 1slave einfache******
;***kommunikation ohne adr zu senden ***********************************
skip_rom:
		ldi			temp1,$cc
		rcall		write_command		;read or write
		ret

;**************************read rom 64bits=8byte*********************
read_rom:
		ldi			temp1,$33			;Befehl
		rcall		write_command		;senden
		rcall		lesen				;Adresse lesen 0 -> 7 + 8tes byte = CRC!!!!!!!!!!!!
		ret

;**************************Adressierung mit 64bit********************
match_rom:
		ldi			temp1,$55			;Befehl
		rcall		write_command		;senden Achtung Adresse ohne CRC senden also nur 8/9byte senden	
		rcall		schreiben			;8bytes schreiben
		ret

;*******************write_scratchpad(schreiben Th und Tl 2byte)******
write_scratchpad:
		ldi			temp1,$4e			;Befehl
		rcall		write_command		;senden
		rcall		load_ID_rng_Y		;lese/schreib Pointer laden
write_scratchpad2:
		ld			temp1,y+			;laden
		rcall		write_command		;Bytes senden
		cpi			yl,temp_lsb+2		;Vergleich auf +2
		brne		write_scratchpad2
		ret	

;*******************read_scratchpad(auslesen der 9byte)**************
read_scratchpad:
		ldi			temp1,$be			;Befehl
		rcall		write_command		;senden
		rcall		lesen				;9bytes lesen
		ret		

;***********Convert---T temperaturmessung starten im ds**************
convert_t:
		ldi			temp1,$44			;Befehl
		rcall		write_command		;senden
		rcall		wait6us				
		cbi			ddrx_ds,pin_ds_x	
		rcall		wait9us				
		sei								;Global INT-Freigabe
		rcall		wait750ms			;unterdrckung 85.00 im disp.
convert_t1:
		sbis		pinx_ds,pin_ds_x
		rjmp		convert_t1
		cli								;Global INT-Sperre
		ret

;*********************auslesen*****************************************
lesen:	rcall		load_ID_rng_Y		;lese/schreib Pointer laden
lesen_2:rcall		read_bit			;Bytes lesen
		st			y+,temp3			;speichern
		cpi			yl,temp_lsb+9		;Vergleich auf +9
		brne		lesen_2
		ret

;*********************schreiben**************************************
schreiben:
		rcall		load_ID_rng_Y		;lese/schreib Pointer laden
schreiben_2:
		ld			temp1,y+			;laden
		rcall		write_command		;Bytes lesen
		cpi			yl,temp_lsb+8		;Vergleich auf +8
		brne		schreiben_2
		ret

;*****************************RESETPULS*********************************
ds_reset:
		sbi			ddrx_ds,pin_ds_x		
		cbi			portx_ds,pin_ds_x		;puls senden
		rcall		wait500us				;
		cbi		 	ddrx_ds,pin_ds_x		;freigabe fr DS
		rcall		wait70us				
wait_puls:
		sbic		pinx_ds,pin_ds_x
		rjmp		wait_puls				;falls bus high zurck
wait_puls_end:								;auf Antwort warten
		sbis		pinx_ds,pin_ds_x
		rjmp		wait_puls_end			;falls bus low zurck
		ret

;************************Unterprogramme******************************
;Byte schreiben
write_command:
		ldi			temp2,$08			;8Bits 
write_command1:
		sbrs		temp1,0
		rcall		write_0				;schreibe 1
		sbrc		temp1,0
		rcall		write_1				;schreibe 0
		lsr			temp1				;hier schiebbefehl von ror auf lsr gendert sonst
		dec			temp2				;wenn ror muss unter read_bit clc eingefgt werden
		brne		write_command1		;hatte auf UniqueSerial keinen einfluss weil kein bit im C 
		ret								;stand

write_1:cbi			portx_ds,pin_ds_x
		sbi			ddrx_ds,pin_ds_x
		rcall		wait6us
		cbi			ddrx_ds,pin_ds_x
		rcall		wait64us
		ret

write_0:cbi			portx_ds,pin_ds_x
		sbi			ddrx_ds,pin_ds_x
		rcall		wait60us
		cbi			ddrx_ds,pin_ds_x
		rcall		wait10us
		ret

;Byte lesen
read_bit:
		clc								;
		clr			temp3				;datenwort in temp3
		ldi			temp4,$08			;8bits
read_bit0:
		lsr			temp3				;hier ror zu lsr gendertvweil bei temp ein bit zuviel
		cbi			portx_ds,pin_ds_x	;DS anstupsen um
		sbi			ddrx_ds,pin_ds_x	;nchstes Bit zu holen
		rcall		wait6us				;warten
		cbi			ddrx_ds,pin_ds_x	;Pin fr DS freigeben
		rcall		wait9us				;warten
		sbis		pinx_ds,pin_ds_x	;abfrage auf
		rjmp		read_bit1			;0 lesen
		ldi 		temp2,$80			;1 lesen
		add 		temp3,temp2
		rjmp 		read_bit2
read_bit1:
		ldi			temp2,$00
		add			temp3,temp2
read_bit2:
		rcall		wait55us
		dec			temp4
		brne		read_bit0
		ret

;*****Division /2 liest erst MSB fr +- dann Berechnen ************
Diven_2:rcall		load_dstemp_Y		;startadress fr Bereich wo die Temps gespeichert werden
		rcall		Diven_3		
Diven_22:
		lds			temp0,temp_msb
		cpi			temp0,$ff			;Vergleich auf Minus
		breq		diven_minus
diven_plus:
		ldi			temp0,'+'
		st			y+,temp0
		lds			temp0,temp_lsb
		lsr			temp0
		st			y+,temp0
		rcall		diven_komma
		st			y+,temp0
		ret

diven_minus:
		ldi			temp0,'-'
		st			y+,temp0
		lds			temp0,temp_lsb
		neg			temp0
		lsr			temp0
		st			y+,temp0
		rcall		diven_komma
		st			y+,temp0		
		ret

diven_komma:
		in			temp1,SREG
		sbrc		temp1,SREG_C
		rcall		set_half
		sbrs		temp1,SREG_C
		rcall		clr_half
		ret

set_half:
		ldi			temp0,$32
		ret

clr_half:
		clr			temp0
		ret

Diven_3:ld			temp0,y
		cpi			temp0,'+'
		breq		Diven_31
		cpi			temp0,'-'
		breq		Diven_31
		ret
Diven_31:
		adiw		yh:yl,$03
		rjmp		Diven_3
		
;***********************Zeiteschleifen*******************************

