;!!!!!!!!!!! ROR-Befehle in READ und WRITE ROUTINE fr DS durch LSR ersetzt muss unbedingt
; 			 getestet werden auf FUNKTION wenn geg. dann ror lschen aber CLC in READ-Routine
;			 beibehalten da auch LSR das C beeinflusst!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

;###########################################
;# Projekt: 								# 
;# 											#
;#											#
;# Taktfrequenz des AVR: 4 MHz	 			#
;# 											#
;# CS-SOFT 									#
;###########################################

.include "m8def.inc"	;Atmega8

.def math1h 	= r8
.def math1l 	= r9
.def math2h 	= R10
.def math2l 	= r11
.def matherghh	= r12
.def mathergh	= r13
.def mathergl	= r14
.def mathergll	= r15

.def temp0 = r16 	; 
.def temp1 = r17 	;
.def temp2 = r18
.def temp3 = r19 	;
.def temp4 = r20
.def cnt   = r21

.equ cpu	= 4000000
.equ Baud	= 9600
.equ UBRRx	= cpu/(16*Baud)-1

/*
;**********LCD Port mit 74HC164
.equ port_lcd_x = 	portd		
.equ ddrx_lcd_x = 	ddrd
;					Pinbelegungen
;                  			   STD
.equ SClock		= 				2		;LCD	;;;
.equ SRS		=				2
.equ SData		= 				4		;74164	;;;;;so Kann die HW angeschlossen sein
.equ SRW		=				4
.equ Light		= 				5		;LCD	;;;;;
.equ SEnable	= 				6		;74164	;;;

;**********LCD-Port parallel fr LCD-Simulationssoftware HapSim
.equ 	port_lcd_x = portd				;auch fr parallel notwendig
.equ 	ddrx_lcd_x = ddrd				;auch fr parallel notwendig
.equ st_port_lcd_x = portb
.equ st_ddrx_lcd_x = ddrb
;					Pinbelegungen
;                 			   STD		;
.equ RS			=				0		;
.equ RW			=				1
.equ Light		= 				2		;
.equ Enable		= 				3		;

;Entry Set
.equ SH			=	0 ;1 = Display shift	0 = not shifted
.equ ID			=	1 ;1 = increase 		0 = decrease
.equ HES		=	2 ;immer 1 setzen Symbolisiert das Ende 
                      ;des Commandos
;DISPLAY on/off
.equ B			=	0 ;1 = Blink 		0 = no Blink
.equ C			=	1 ;1 = Cursor on 	0 = Cursor off
.equ D			=	2 ;1 = Disp on		0 = Disp off
.equ HD			=	3 ;immer 1 setzen Symbolisiert das Ende 
                      ;des Commandos
;Shift
.equ RL			=	2 ;1 = right shift	0 = left shift
.equ SC			=	3 ;1 = Disp shift	0 = Cursor move
.equ HS			=	4 ;immer 1 setzen Symbolisiert das Ende 
                      ;des Commandos
;SET Function
.equ F			=	2 ;1 = 5x10			0 = 5x7
.equ N			=	3 ;1 = 2line(4line)	0 = 1line
.equ DL			=	4 ;1 = 8bit int		0 = 4bit interface
.equ HSF		=	5 ;immer 1 setzen Symbolisiert das Ende 
                      ;des Commandos
*/
;****DS18S20 auf port -->
.equ ddrx_ds		= ddrc	
.equ portx_ds		= portc
.equ pinx_ds		= pinc
.equ pin_ds_x		= 0
.equ dsIDrng		= $0080		;Speicherbereich fr DS-ID's = Y-Pointer wird nur temporr genutzt
.equ dstemp			= $0090		;Speicherbereich fr Temp mit Kommastelle = X-Pointer

;**********SRAM
.equ 	erg_k		=	$0060			;erg_k wird bis zu 5 weiteren bytes genutzt sprich erg_k+5
.equ 	ocr2s		=	$0065			;fr T2
.equ 	ocra1h		=	$0066			;;;;;
.equ 	ocra1l		=	$0067			;;;;;;;; fr T1 A channel
.equ 	ocrb1h		=	$0068			;;;;;
.equ 	ocrb1l		=	$0069			;;;;;;;; fr T1 B channel
.equ 	icr1xh		=	$006a			;;;;;
.equ 	icr1xl		=	$006b			;;;;;;;; fr T1 ICR
.equ	hadc		=	$006c			;adc
.equ	ladc		=	$006d			;adc
.equ	eep_adrh	=	$006e			;eeprom
.equ	eep_adrl	=	$006f			;eeprom
.equ	LTC_wertH	=	$0070
.equ	LTC_wertL	=	$0071
.equ	Poti0		=	$0072			;Potentiometer 0
.equ	ploudr		=	$0073			;poti fr lautstrke rechts
.equ	ploudl		=	$0074			;poti fr lautstrke links
.equ	phigh		=	$0075			;poti fr hhen		
.equ	pbass		=	$0076			;poti fr bass
.equ 	halbeh		=	$0077		;
.equ	halbel		=	$0078

.equ 	temp_lsb	=	$0080		;
.equ 	temp_msb	=	$0081		;
.equ 	th_register	=	$0082		;
.equ 	tl_register	=	$0083		;
.equ 	res_byte4	=	$0084		;
.equ 	res_byte5	=	$0085		;
.equ 	cnt_remain	=	$0086		;
.equ 	cnt_per_c	=	$0087		;
.equ 	crc			=	$0088		;gesperrt ID wird ausgelesen aber nicht gespeichert
.equ	dsnmax		=	$0089
	
;***************************Einsprungadressen***********************
.cseg
.org $0000
	rjmp	stack
.org $0001			;1
	reti;rjmp	INT_0
.org $0002			;2
	reti;rjmp	INT_1
.org $0003			;3
	reti;rjmp	INT_OC2
.org $0004			;4
	reti;rjmp	INT_OVF2
.org $0005			;5
	reti;rjmp	INT_ICP1
.org $0006			;6
	reti;rjmp	INT_OC1A
.org $0007			;7
	reti;rjmp	INT_OC1B
.org $0008			;8
	reti;rjmp	INT_OVF1
.org $0009			;9
	reti;rjmp	INT_OVF0

		reti		;a keine SPI Routinen

.org $000b			;b
	reti;rjmp	INT_URXC
.org $000c			;c
	reti;rjmp	INT_UDRE
.org $000d			;d
	reti;rjmp	INT_UTXC
.org $000e			;e
	reti;rjmp	adc_rdy
.org $000f			;f
	reti;rjmp	eeprom_rdy
.org $0010			;10
	reti;rjmp	ac_int

		reti		;11	keine 2wireRoutinen
		reti		;12 keine SPMRoutinen

;***************************Init mit allem drumdran*****************

stack:	ldi 		temp1,high(ramend)  ;Stackpointer festlegen
	    out 		sph, temp1
		ldi 		temp1,low(ramend)   ;Stackpointer festlegen
        out 		spl, temp1
		rcall		sram				

		ldi			temp0,(1<<pb0|1<<pb1|1<<pb2|1<<pb3)
		out			portb,temp0
		
		rcall		usart_init			;Uart initalisieren
		rcall		werbe1_rs			;Werbung
	;	rcall		wait1s
		
;***********************masterprogramm*******************************
start:	sbis		pinb,0
		rcall		pc_ser				;SerienNummer erfassen 1nes Sensor und in EEP speichern und Ausgabe RS232
		
		sbis		pinb,2
		rcall		ds_mess_adr			;Temp von n-Sensoren mit Adresse auslesen und Ausgabe RS232
		sbis		pinb,3
		rcall		ds_mess				;Temp 1nes Sensors auslesen und Ausgabe RS232
		rjmp		start

;*******************ber RS232 Anzeige SerialNummer**************************
pc_ser:	rcall		wait150ms			;warten
		rcall		txt_adr_rs			;Txt an RS232
		rcall		ds18_get_ser		;Adresse + EEP 
		rcall		adr_hex_ASCII_rs	;Ausgabe auf RS232
		ret

;******************Messung mehrerer Sensoren ber Adresse + Temp auf LCD*****
ds_mess_adr:
		rcall		wait150ms			;warten
		rcall		ds18_t_adr			;TempAdress lesen
		rcall		temp_rs232			;Ausgabe auf RS232
		ret

;******************Messung eines Sensors + Temp auf LCD**********************
ds_mess:rcall		wait150ms			;warten
		rcall		ds18_t_skip_rom		;Temp 1 Sensors
		rcall		temp_rs232_1		;Ausgabe auf RS232
		ret

;*******************Asugabe auf RS232****************************************
temp_rs232:
		clr			cnt					;lschen
		rcall		rd_ds_n				;Anzahl der DS laden
		rcall		load_dstemp_Y		;Temperaturspeicherbereich laden
temp_rs232_2:			
		rcall		txt_DSn_rs			;Textausgabe
		inc			cnt					;+1
		push		cnt					;on stack
		mov			temp1,cnt			;moven
		rcall		zahl_out_rs1		;Ausgabe Zahl
		rcall		leer_zeichen_rs232	;leerzeichen		
	
		ld			temp1,y				;von fester Adr laden
		rcall		data_transmit		;senden
		subi		temp1,$20			;+- Zeichen zerstren sonst wird endlos gespeichert
		st			y+,temp1			;zurckspeichern y+1

		rcall		temp_rs_load		;hier erfolgt Ausgabe Hex->Dez + Ausgabe der Zehner+Einer 
		rcall		txt_punkt_rs
		rcall		temp_rs_load		;hier erfolgt Ausgabe Hex->Dez + Ausgabe der Zehner+Einer 	
		rcall		txt_grad_cel_rs
		rcall		enter_rs232			;Enter1
		
		pop			cnt					;from stack
		lds			temp1,dsnmax		;Sensoranzahl
		cp			cnt,temp1			;vergleich
		brne		temp_rs232_2		;!= spring
		rcall		enter_rs232			;Enter2
		ret

temp_rs232_1:
		rcall		load_dstemp_Y		;Temperaturbereich laden
		rcall		txt_DSn_rs			;Textausgabe
		ldi			temp1,$01			;
		rcall		zahl_out_rs1		;Ausgabe Zahl
		rcall		leer_zeichen_rs232			
	
		ld			temp1,y				;von fester Adr laden
		rcall		data_transmit		;senden
		subi		temp1,$20			;+- Zeichen zerstren sonst wird endlos im Ram gespeichert
		st			y+,temp1			;zurckspeichern y+1

		rcall		temp_rs_load		;hier erfolgt Ausgabe Hex->Dez + Ausgabe der Zehner+Einer 
		rcall		txt_punkt_rs
		rcall		temp_rs_load		;hier erfolgt Ausgabe Hex->Dez + Ausgabe der Zehner+Einer 	
		rcall		txt_grad_cel_rs
		rcall		enter_rs232			;Enter1
		
		ret

;**********************Masterclr***************************************
sram:	clr			temp0
		ldi			yl,low($0060)
		ldi			yh,high($0060)			;Masterclr des Sram's ber
sram2:	st			y+,temp0				;die indirekte Adressierung
		cpi			yl,$a0					;bis zur zelle x lschen
		brne		sram2		
		ret

;*******************Ausgabe RS232************************************
werbe1_rs:
		ldi			zh,high(out1*2)
		ldi			zl,low(out1*2)
		rcall		txt_out_rs
		rcall		enter_rs232
		ret

txt_adr_rs:
		ldi			zh,high(out2*2)
		ldi			zl,low(out2*2)
		rcall		txt_out_rs
		ret

txt_DSn_rs:
		ldi			zh,high(out3*2)
		ldi			zl,low(out3*2)
		rcall 		txt_out_rs
		ret

txt_grad_cel_rs:
		ldi			zh,high(out4*2)
		ldi			zl,low(out4*2)
		rcall 		txt_out_rs
		ret

txt_punkt_rs:
		ldi			zh,high(out5*2)
		ldi			zl,low(out5*2)
		rcall 		txt_out_rs
		ret

;****************DatenBank******************************************
out1:	.db "DS18S20 + RS232",$ff
out2:	.db "DS Adr: ",$ff
out3:	.db "DS",$ff
out4:	.db "C",$ff
out5:	.db ".",$ff

;*************************weitere*includedata***********************
.include "ds1820.asm"													;ds1820 
;.include "j:\etronik\Software3\sonstiges\origin\lcd_KS0066_KS0070_8bit.asm" 	;LCD-Routinen 
;.include "l:\etronik\Software3\sonstiges\origin\lcd_KS0066_KS0070_8bit_HapSim.asm"
.include "j:\etronik\Software3\sonstiges\origin\EEprom.asm"
.include "j:\etronik\Software3\sonstiges\origin\uart_std.asm"
.include "j:\etronik\Software3\sonstiges\origin\zeitschleifen.asm"
;*************************ENDE**************************************
